RollingFileAppender (Apache Log4j 1.2.17 API)
Date: 2012-05-06

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.log4j
Class RollingFileAppender

    java.lang.Object
      org.apache.log4j.AppenderSkeleton
          org.apache.log4j.WriterAppender
              org.apache.log4j.FileAppender
                  org.apache.log4j.RollingFileAppender

All Implemented Interfaces:
  Appender, OptionHandler

Direct Known Subclasses:
  ExternallyRolledFileAppender

    public class RollingFileAppender

extends FileAppender

RollingFileAppender extends FileAppender to backup the log files when they reach a certain size. The log4j extras companion includes alternatives which should be considered for new deployments and which are discussed in the documentation for org.apache.log4j.rolling.RollingFileAppender.

Author:
  Heinz Richter, Ceki Gülcü

Field Summary
`protected int` | `maxBackupIndex` There is one backup file by default.
`protected long` | `maxFileSize` The default maximum file size is 10MB.

Fields inherited from class org.apache.log4j.FileAppender
`bufferedIO, bufferSize, fileAppend, fileName`

Fields inherited from class org.apache.log4j.WriterAppender
`encoding, immediateFlush, qw`

Fields inherited from class org.apache.log4j.AppenderSkeleton
`closed, errorHandler, headFilter, layout, name, tailFilter, threshold`

Constructor Summary
`RollingFileAppender()` The default constructor simply calls its `parents constructor`.
`RollingFileAppender(Layout layout, String filename)` Instantiate a FileAppender and open the file designated by `filename`.
`RollingFileAppender(Layout layout, String filename, boolean append)` Instantiate a RollingFileAppender and open the file designated by `filename`.

Method Summary
`int` | `getMaxBackupIndex()` Returns the value of the MaxBackupIndex option.
`long` | `getMaximumFileSize()` Get the maximum size that the output file is allowed to reach before being rolled over to backup files.
`void` | `rollOver()` Implements the usual roll over behaviour.
`void` | `setFile(String fileName, boolean append, boolean bufferedIO, int bufferSize)` Sets and opens the file where the log output will go.
`void` | `setMaxBackupIndex(int maxBackups)` Set the maximum number of backup files to keep around.
`void` | `setMaxFileSize(String value)` Set the maximum size that the output file is allowed to reach before being rolled over to backup files.
`void` | `setMaximumFileSize(long maxFileSize)` Set the maximum size that the output file is allowed to reach before being rolled over to backup files.
`protected void` | `setQWForFiles(Writer writer)` Sets the quiet writer being used.
`protected void` | `subAppend(LoggingEvent event)` This method differentiates RollingFileAppender from its super class.

Methods inherited from class org.apache.log4j.FileAppender
`activateOptions, closeFile, getAppend, getBufferedIO, getBufferSize, getFile, reset, setAppend, setBufferedIO, setBufferSize, setFile`

Methods inherited from class org.apache.log4j.WriterAppender
`append, checkEntryConditions, close, closeWriter, createWriter, getEncoding, getImmediateFlush, requiresLayout, setEncoding, setErrorHandler, setImmediateFlush, setWriter, shouldFlush, writeFooter, writeHeader`

Methods inherited from class org.apache.log4j.AppenderSkeleton
`addFilter, clearFilters, doAppend, finalize, getErrorHandler, getFilter, getFirstFilter, getLayout, getName, getThreshold, isAsSevereAsThreshold, setLayout, setName, setThreshold`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### maxFileSize

    protected long maxFileSize

  The default maximum file size is 10MB.

### maxBackupIndex

    protected int maxBackupIndex

  There is one backup file by default.

Constructor Detail

### RollingFileAppender

    public RollingFileAppender()

  The default constructor simply calls its `parents constructor`.

### RollingFileAppender

    public RollingFileAppender(Layout layout,
                               String filename,
                               boolean append)
                        throws IOException

  Instantiate a RollingFileAppender and open the file designated by `filename`. The opened filename will become the ouput destination for this appender.

  If the `append` parameter is true, the file will be appended to. Otherwise, the file desginated by `filename` will be truncated before being opened.

  Throws:
    `IOException`

### RollingFileAppender

    public RollingFileAppender(Layout layout,
                               String filename)
                        throws IOException

  Instantiate a FileAppender and open the file designated by `filename`. The opened filename will become the output destination for this appender.

  The file will be appended to.

  Throws:
    `IOException`

Method Detail

### getMaxBackupIndex

    public int getMaxBackupIndex()

  Returns the value of the MaxBackupIndex option.

### getMaximumFileSize

    public long getMaximumFileSize()

  Get the maximum size that the output file is allowed to reach before being rolled over to backup files.

  Since:
    1.1

### rollOver

    public void rollOver()

  Implements the usual roll over behaviour.

  If `MaxBackupIndex` is positive, then files {`File.1`, ..., `File.MaxBackupIndex -1`} are renamed to {`File.2`, ..., `File.MaxBackupIndex`}. Moreover, `File` is renamed `File.1` and closed. A new `File` is created to receive further log output.

  If `MaxBackupIndex` is equal to zero, then the `File` is truncated with no backup files created.

### setFile

    public void setFile(String fileName,
                        boolean append,
                        boolean bufferedIO,
                        int bufferSize)
                 throws IOException

  Description copied from class: `FileAppender`

  Sets and opens the file where the log output will go. The specified file must be writable.

  If there was already an opened file, then the previous file is closed first.

  Do not use this method directly. To configure a FileAppender or one of its subclasses, set its properties one by one and then call activateOptions.

  Overrides:
    `setFile` in class `FileAppender`
  Parameters:
    `fileName` - The path to the log file.
    `append` - If true will append to fileName. Otherwise will truncate fileName.
  Throws:
    `IOException`

### setMaxBackupIndex

    public void setMaxBackupIndex(int maxBackups)

  Set the maximum number of backup files to keep around.

  The MaxBackupIndex option determines how many backup files are kept before the oldest is erased. This option takes a positive integer value. If set to zero, then there will be no backup files and the log file will be truncated when it reaches `MaxFileSize`.

### setMaximumFileSize

    public void setMaximumFileSize(long maxFileSize)

  Set the maximum size that the output file is allowed to reach before being rolled over to backup files.

  This method is equivalent to `setMaxFileSize(java.lang.String)` except that it is required for differentiating the setter taking a `long` argument from the setter taking a `String` argument by the JavaBeans `Introspector`.

  See Also:
    `setMaxFileSize(String)`

### setMaxFileSize

    public void setMaxFileSize(String value)

  Set the maximum size that the output file is allowed to reach before being rolled over to backup files.

  In configuration files, the MaxFileSize option takes an long integer in the range 0 - 2^63. You can specify the value with the suffixes "KB", "MB" or "GB" so that the integer is interpreted being expressed respectively in kilobytes, megabytes or gigabytes. For example, the value "10KB" will be interpreted as 10240.

### setQWForFiles

    protected void setQWForFiles(Writer writer)

  Description copied from class: `FileAppender`
  Sets the quiet writer being used. This method is overriden by `RollingFileAppender`.

  Overrides:
    `setQWForFiles` in class `FileAppender`

### subAppend

    protected void subAppend(LoggingEvent event)

  This method differentiates RollingFileAppender from its super class.

  Overrides:
    `subAppend` in class `WriterAppender`
  Since:
    0.9.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2012 Apache Software Foundation. All Rights Reserved.